CREATE TABLE categories (
	id serial PRIMARY KEY,
	name varchar(30) NOT NULL UNIQUE
);

CREATE TABLE locations (
	id serial PRIMARY KEY,
	key varchar(120) NOT NULL,
	name varchar(60) NOT NULL UNIQUE
);
	
CREATE TABLE types (
	id serial PRIMARY KEY,
	key varchar(60) NOT NULL,
	name varchar(30) NOT NULL UNIQUE
);

CREATE TABLE transactions (
	id serial PRIMARY KEY,
	date date NOT NULL,
	typeid varchar(60) NOT NULL,
	locationid int REFERENCES locations (id),
	amount numeric(10,2) NOT NULL
);

CREATE TABLE transaction_categories (
	id SERIAL PRIMARY KEY,
	transactionid int REFERENCES transactions (id),
	categoryid int REFERENCES categories (id)
);

INSERT INTO types (key, name) VALUES ('Check Card-Withdrawal','Credit');
INSERT INTO types (key, name) VALUES ('ATM-Withdrawal', 'ATM');
INSERT INTO types (key, name) VALUES ('Withdrawal', 'Withdrawl');
INSERT INTO types (key, name) VALUES ('Deposit', 'Deposit');
INSERT INTO types (key, name) VALUES ('Internet Transfer', 'Transfer');
