#!/usr/local/bin/python
"""hapo.py: Fetch a CSV of transactions from hapo."""

import curl, time

# Vars
accountnum = ''
password = ''

# Perform the login
hapoweb = curl.Curl()
hapoweb.set_url('https://secure2.hapo.org/')
args = {'newusername': accountnum, 'newpassword': password}
hapoweb.post('login.php', args)

def getCSV(month, year=2006, account='S9'):
	lastday = {1: 31, 2: 28, 3: 31, 4: 30, 5: 31, 6: 30, 7: 31, 8: 31, 9: 30, 10: 31, 11: 30, 12: 31}
	startdate = int(time.mktime((year, month, 1, 16, 20, 00, 4, 90, 0)))
	enddate = int(time.mktime((year, month, lastday[month], 1, 38, 16, 4, 90, 0)))
	hapoweb.get('download.php?acct='+accountnum+'-'+account+'&atype=checking&d1='+str(startdate)+'&d2='+str(enddate))
	csv = hapoweb.get('downloadcsv/'+accountnum+'-'+account+'.csv')
	return csv.split('\n')[2:]

def logout():
	return hapoweb.get('logout.php')

if __name__ == '__main__':
	print getCSV(2)
