"""General library for accessing my finances."""

import postgres, re

def insertTransaction(date, typeId, locationId, amount, categoryIds):
	"""Add a new transaction to the record.
	"""
	transaction = [{'date': date, 'typeid': typeId, 'locationid': locationId, 'amount': amount}]
	print postgres.insert('transactions', transaction)
	transactionId = postgres.query("SELECT id FROM transactions WHERE date = '"+date+"' AND typeid = "+str(typeId)+" AND locationid = "+str(locationId)+" AND amount = "+str(amount))[0]['id']
	categories = []
	for categoryId in categoryIds:
		categories.append({'transactionid': transactionId, 'categoryid': categoryId})
	postgres.insert('transaction_categories', categories)


def checkTransaction(date, typeId, locationId, amount):
	"""Returns true when the transaction described exists in the database.
	"""
	transactionCount = postgres.query("SELECT COUNT(*) AS count FROM transactions WHERE date = '"+date+"' AND typeid = "+str(typeId)+" AND locationid = "+str(locationId)+" AND amount = "+str(amount))[0]['count']
	if transactionCount > 0:
		return True
	else:
		return False


def lookupType(type):
	type = re.sub(r"'", "''", type)
	return postgres.query("SELECT id FROM types WHERE key = '"+type+"'")[0]['id']

def lookupLocation(location):
	location = re.sub(r"'", "''", location)
	return postgres.query("SELECT id FROM locations WHERE key = '"+location+"'")[0]['id']


def lookupLocationName(locationId):
	return postgres.query("SELECT name FROM locations WHERE id = '"+str(locationId)+"'")[0]['name']


def addLocation(key, name):
	key = re.sub(r"'", "''", key)
	name = re.sub(r"'", "''", name)
	postgres.execute("INSERT INTO locations (key, name) VALUES ('"+key+"', '"+name+"')") 
	return lookupLocation(key)


def addLocationInteractive(location):
	print 'Location Not Found: ', location
	newlocation = raw_input('Enter location name: ')
	return addLocation(location, newlocation)


def printCategoryList():
	categories = postgres.query("SELECT name FROM categories ORDER BY name")
	print
	x = 0;
	for category in categories:
		maxlen = 15
		if len(category['name']) > maxlen:
			category['name'] = category['name'][:maxlen]
		else:
			category['name'] = category['name'] + ' ' * (maxlen - len(category['name']))
		print "'"+category['name']+"' ",
		if x == 3:
			print
			x = 0
		else:
			x+=1
	print


def getCategories():
	categories = raw_input('Categories: ').split(',')
	tags = []
	for i in categories:
		category = re.sub(r"'", "''", i)
		try:
			categoryId = postgres.query("SELECT id FROM categories WHERE name = '"+category+"'")[0]['id']
		except IndexError:
			postgres.execute("INSERT INTO categories (name) VALUES ('"+category+"')")
			categoryId = postgres.query("SELECT id FROM categories WHERE name = '"+category+"'")[0]['id']
		tags.append(categoryId)
	return tags

def listTransactions():
	return postgres.query("SELECT t.id, t.date, t.amount, types.name AS type, l.name AS location FROM transactions t INNER JOIN types ON t.typeid = types.id INNER JOIN locations l ON t.locationid = l.id ORDER BY t.date, t.id")

def listCategoryTransactions(categoryId):
	return postgres.query("SELECT t.id AS transactionid, t.date, t.amount, types.name AS type, c.name AS category FROM transactions t INNER JOIN transaction_categories tc ON t.id = tc.transactionid INNER JOIN types ON t.typeid = types.id INNER JOIN categories c ON tc.categoryid = c.id WHERE c.id = "+str(categoryId)+" ORDER BY date, t.id")

def listCategories():
	return postgres.query("SELECT * FROM categories ORDER BY id")
