#!/usr/local/bin/python
"""Database abstraction script. Rather then use queries directly in my script
this script will handle them. This will make it easy to swap out the database
later on."""

import psycopg

username='zwhite'
password='fuckyou'
host='127.0.0.1'
port='5432'
database='finance'

# Connect to the database.
_dbconnection = psycopg.connect(dsn='dbname='+database+' host='+host+
    ' port='+port+' user='+username+' password='+password)

def execute(sql):
	"""Executes a SQL query and returns nothing."""

	cursor = _dbconnection.cursor()
	cursor.execute(sql)
	_dbconnection.commit()
	del(cursor)


def query(sql):
	"""Executes a SQL query and returns a tuple of dictionaries containing
	the results. Returns None when there are no results.
	"""
	cursor = _dbconnection.cursor()
	cursor.execute(sql)
	result = cursor.dictfetchall()
	_dbconnection.commit()
	return result


def openTable(table, columns="*", where='', params=''):
	"""Returns a tuple of dictionaries for the table specified.

	table: The table you wish to open.

	columns: If specified, contains a string with a comma seperated list 
	         of columns to select on.

	where: If specified, contains a string with a WHERE clause.

	params: If specified, contains any other SQL parameters you wish to add
	        to the query, for example LIMIT or ASC.
	"""

	cursor = _dbconnection.cursor()
	if len(where) > 5 and where[:5] != 'WHERE':
		where = 'WHERE ' + where
	cursor.execute("""SELECT %s FROM %s %s %s""" % (columns,table,where,params))
	return cursor.dictfetchall()


def insert(table, rows):
	"""Inserts data into the database. Returns the number of rows inserted.

	table: A string containing the table to insert into.

	rows: A list of dictionaries containing the data to be inserted. Each
	      dictionary must have the column name as the key and the value
	      as the value.
	"""

	keys = rows[0].keys()
	mykeys=''
	ikeys=''
	for key in keys:
		if ikeys == '':
			mykeys+=key
			ikeys+='%%(%s)s' % key
		else:
			mykeys+=', ' + key
			ikeys+=', %%(%s)s' % key

	cursor = _dbconnection.cursor()
	cursor.executemany("""INSERT INTO %s (%s) VALUES (%s)""" % (table,mykeys,ikeys), rows)
	rowcount = cursor.rowcount
	_dbconnection.commit()
	return rowcount


if __name__ == '__main__':
	pass
